
public class BoardingQueue {

    private Passenger[] passenger= new Passenger[10];
    private int front;
    private int rear;
    private int size;

    public BoardingQueue() {
        front = 0;
        rear = 0;
        size =0;
    }

    public void enqueuePassenger(Passenger newPass) throws NoRoomException {
        //Do not add when queue is full
        if(size >= 10)
            throw new  NoRoomException("No More room in the queue");

        //if no passenger add this passenger to the front
        if(size == 0 || newPass.getPassClass().equals(TravelClass.ECONOMY)) {
            passenger[size++] = newPass;
            rear++;
            return;
        }

        for (int i = 0; i < passenger.length; i++) {
            if(passenger[i] == null) {
                passenger[i] = newPass;
                break;
            }

            else if (passenger[i].getPassClass().equals(newPass.getPassClass()))
                if (passenger[i].getPassengerID() > newPass.getPassengerID()){
                    Passenger[] temp = new Passenger[10];
                    System.arraycopy(passenger, 0, temp, 0, i+1);
                    temp[i] = newPass;

                    if (passenger.length - (i + 1) >= 0)
                        System.arraycopy(passenger, i, temp, i + 1, passenger.length - (i + 1));

                    passenger = temp;
                    break;
                }
        }


        rear++;
        size++;
    }

    public Passenger dequeuePassenger() throws NoPassengerException {
        if(size == 0)
            throw new NoPassengerException("No passenger on the queue");


        Passenger boardingPassenger= passenger[front];
        Passenger[] temp = new Passenger[10];
        System.arraycopy(passenger, 1, temp, 0, 9);

        passenger= temp;
        size--;
        rear--;


        return boardingPassenger;
    }

    public Passenger[] getPassenger() {
        return passenger;
    }

    public void setPassenger(Passenger[] passenger) {
        this.passenger = passenger;
    }

    public int getFront() {
        return front;
    }

    public void setFront(int front) {
        this.front = front;
    }

    public int getRear() {
        return rear;
    }

    public void setRear(int rear) {
        this.rear = rear;
    }

    public int getSize() {
        return size;
    }

    public void setSize(int size) {
        this.size = size;
    }
}
